## colmap 3.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.11)

project(COLMAP)

set(COLMAP_VERSION "3.4")
set(COLMAP_VERSION_NUMBER "3400")


################################################################################
# Include CMake dependencies
################################################################################

set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)

include(CheckCXXCompilerFlag)

# Include helper macros and commands, and allow the included file to override
# the CMake policies in this file
include(${CMAKE_SOURCE_DIR}/cmake/CMakeHelper.cmake NO_POLICY_SCOPE)

include(${CMAKE_SOURCE_DIR}/cmake/CheckSSEExtensions.cmake)

if(EXISTS ${CMAKE_SOURCE_DIR}/LocalConfig.cmake)
    include(${CMAKE_SOURCE_DIR}/LocalConfig.cmake)
endif()


################################################################################
# Options
################################################################################

option(OPENMP_ENABLED "Whether to enable OpenMP" ON)
option(IPO_ENABLED "Whether to enable interprocedural optimization" ON)
option(CUDA_ENABLED "Whether to enable CUDA, if available" ON)
option(OPENGL_ENABLED "Whether to enable OpenGL, if available" ON)
option(TESTS_ENABLED "Whether to build test binaries" OFF)
option(PROFILING_ENABLED "Whether to enable google-perftools linker flags" OFF)
option(BOOST_STATIC "Whether to enable static boost library linker flags" ON)
option(CUDA_MULTI_ARCH "Whether to generate CUDA code for multiple architectures" OFF)

if(TESTS_ENABLED)
    enable_testing()
endif()

if(BOOST_STATIC)
    set(Boost_USE_STATIC_LIBS ON)
else()
    add_definitions(-DBOOST_TEST_DYN_LINK)
endif()

################################################################################
# Find packages
################################################################################

if(OPENMP_ENABLED)
    find_package(OpenMP QUIET)
endif()

find_package(Boost COMPONENTS
             program_options
             filesystem
             regex
             system
             unit_test_framework
             REQUIRED)

find_package(Eigen3 REQUIRED)

find_package(FreeImage REQUIRED)

find_package(Glog REQUIRED)

find_package(Ceres REQUIRED)

find_package(OpenGL REQUIRED)
find_package(Glew REQUIRED)
find_package(Git)

set(CUDA_MIN_VERSION "7.0")
if(CUDA_ENABLED)
    find_package(CUDA ${CUDA_MIN_VERSION} QUIET)
endif()

find_package(Qt5 5.4 REQUIRED)


################################################################################
# Compiler specific configuration
################################################################################

if(CMAKE_BUILD_TYPE)
    message(STATUS "Build type specified as ${CMAKE_BUILD_TYPE}")
else()
    message(STATUS "Build type not specified, using Release")
    set(CMAKE_BUILD_TYPE Release)
    set(IS_DEBUG FALSE)
endif()

if(IS_MSVC)
    add_definitions("-DGLOG_NO_ABBREVIATED_SEVERITIES")
    add_definitions("-DGL_GLEXT_PROTOTYPES")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /EHsc")
else()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
endif()

if(IS_GNU)
    # Hide incorrect warnings for uninitialized Eigen variables under GCC.
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-maybe-uninitialized")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-maybe-uninitialized")
endif()

if(IS_DEBUG)
    add_definitions("-DEIGEN_INITIALIZE_MATRICES_BY_NAN")
endif()

if(OPENMP_ENABLED AND OPENMP_FOUND)
    message(STATUS "Enabling OpenMP support")
    add_definitions("-DOPENMP_ENABLED")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
else()
    message(STATUS "Disabling OpenMP support")
endif()

if(IPO_ENABLED AND NOT IS_DEBUG AND NOT IS_GNU)
    message(STATUS "Enabling interprocedural optimization")
    set_property(DIRECTORY PROPERTY INTERPROCEDURAL_OPTIMIZATION 1)
else()
    message(STATUS "Disabling interprocedural optimization")
endif()

if(CUDA_FOUND)
    if(CUDA_ENABLED)
        add_definitions("-DCUDA_ENABLED")

        include(${CMAKE_SOURCE_DIR}/cmake/SelectCudaComputeArch.cmake)

        if(CUDA_MULTI_ARCH)
            CUDA_SELECT_NVCC_ARCH_FLAGS(CUDA_ARCH_FLAGS All)
        else()
            CUDA_SELECT_NVCC_ARCH_FLAGS(CUDA_ARCH_FLAGS Auto)
        endif()

        list(APPEND CUDA_NVCC_FLAGS "-Wno-deprecated-gpu-targets")
        list(APPEND CUDA_NVCC_FLAGS ${CUDA_ARCH_FLAGS})

        message(STATUS "Enabling CUDA support (version: ${CUDA_VERSION_STRING},"
                       " archs: ${CUDA_ARCH_FLAGS_readable})")
    else()
        set(CUDA_FOUND FALSE)
        message(STATUS "Disabling CUDA support")
    endif()
else()
    set(CUDA_ENABLED FALSE)
    if(CUDA_VERSION_STRING)
        message(STATUS "Disabling CUDA support (found version "
                "${CUDA_VERSION_STRING} but >= ${CUDA_MIN_VERSION} required)")
    else()
        message(STATUS "Disabling CUDA support")
    endif()
endif()

if(OPENGL_ENABLED)
    add_definitions("-DOPENGL_ENABLED")
    message(STATUS "Enabling OpenGL support")
else()
    message(STATUS "Disabling OpenGL support")
endif()

if(PROFILING_ENABLED)
    message(STATUS "Enabling profiling support")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -lprofiler -ltcmalloc")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -lprofiler -ltcmalloc")
else()
    message(STATUS "Disabling profiling support")
endif()

# Qt5 was built with -reduce-relocations.
if(Qt5_POSITION_INDEPENDENT_CODE)
    set(CMAKE_POSITION_INDEPENDENT_CODE ON)
    if(CUDA_ENABLED AND NOT IS_MSVC)
        list(APPEND CUDA_NVCC_FLAGS "--compiler-options -fPIC")
    endif()
endif()


################################################################################
# Add sources
################################################################################

include(GenerateVersionDefinitions)

add_subdirectory(src)


################################################################################
# Install/uninstall script
################################################################################

if(IS_MSVC)
    install(FILES "scripts/shell/COLMAP.bat" "scripts/shell/RUN_TESTS.bat"
            PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE
                        GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
            DESTINATION "/")
endif()

configure_file("${CMAKE_SOURCE_DIR}/cmake/CMakeUninstall.cmake"
               "${CMAKE_CURRENT_BINARY_DIR}/CMakeUninstall.cmake"
               IMMEDIATE @ONLY)
add_custom_target(uninstall COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/CMakeUninstall.cmake)
set_target_properties(uninstall PROPERTIES FOLDER ${CMAKE_TARGETS_ROOT_FOLDER})

=== src/CMakeLists.txt ===
include_directories(
    .
    ${Boost_INCLUDE_DIRS}
    ${EIGEN3_INCLUDE_DIRS}
    ${GLOG_INCLUDE_DIRS}
    ${FREEIMAGE_INCLUDE_DIRS}
    ${CERES_INCLUDE_DIRS}
    ${GLEW_INCLUDE_DIRS}
    ${Qt5_INCLUDE_DIRS}
)

link_directories(
    ${Boost_LIBRARY_DIRS}
)

set(COLMAP_LIBRARIES
    mvs
    sfm
    controllers
    base
    feature
    ui
    util
    controllers
    mvs
    sfm
    estimators
    base
    feature
    ui
    util
    estimators
    optim
    retrieval
    estimators
    base
    util
    flann
    graclus
    lsd
    pba
    poisson_recon
    sqlite3
    sift_gpu
    vlfeat
    ${CMAKE_DL_LIBS}
    ${Boost_FILESYSTEM_LIBRARY}
    ${Boost_PROGRAM_OPTIONS_LIBRARY}
    ${Boost_REGEX_LIBRARY}
    ${Boost_SYSTEM_LIBRARY}
    ${GLOG_LIBRARIES}
    ${FREEIMAGE_LIBRARIES}
    ${CERES_LIBRARIES}
    ${OPENGL_gl_LIBRARY}
    ${OPENGL_glu_LIBRARY})

if(CUDA_ENABLED)
    set(COLMAP_LIBRARIES
        mvs
        mvs_cuda
        util_cuda
        ${COLMAP_LIBRARIES}
        mvs
        mvs_cuda
        mvs
        util_cuda)
endif()

if(UNIX)
    set(COLMAP_LIBRARIES ${COLMAP_LIBRARIES} pthread)
endif()

set(COLMAP_QT_MODULES Core Widgets OpenGL)

add_subdirectory(base)
add_subdirectory(controllers)
add_subdirectory(estimators)
add_subdirectory(exe)
add_subdirectory(ext)
add_subdirectory(feature)
add_subdirectory(mvs)
add_subdirectory(optim)
add_subdirectory(retrieval)
add_subdirectory(sfm)
add_subdirectory(tools)
add_subdirectory(ui)
add_subdirectory(util)

# This macro will search for source files in a given directory, will add them
# to a source group (folder within a project), and will then return paths to
# each of the found files. The usage of the macro is as follows:
# ADD_SOURCE_DIR(
#     <source directory to search>
#     <output variable with found source files>
#     <search expressions such as *.h *.cc>)
macro(ADD_SOURCE_DIR SRC_DIR SRC_VAR)
    # Create the list of expressions to be used in the search.
    set(GLOB_EXPRESSIONS "")
    foreach(ARG ${ARGN})
        list(APPEND GLOB_EXPRESSIONS ${SRC_DIR}/${ARG})
    endforeach()
    # Perform the search for the source files.
    file(GLOB ${SRC_VAR} RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}
        ${GLOB_EXPRESSIONS})
    # Create the source group.
    string(REPLACE "/" "\\" GROUP_NAME ${SRC_DIR})
    source_group(${GROUP_NAME} FILES ${${SRC_VAR}})
    # Clean-up.
    unset(GLOB_EXPRESSIONS)
    unset(ARG)
    unset(GROUP_NAME)
endmacro(ADD_SOURCE_DIR)

ADD_SOURCE_DIR(base BASE_SRC *.h *.cc)
ADD_SOURCE_DIR(controllers CONTROLLERS_SRC *.h *.cc)
ADD_SOURCE_DIR(estimators ESTIMATORS_SRC *.h *.cc)
ADD_SOURCE_DIR(exe EXE_SRC *.h *.cc)
ADD_SOURCE_DIR(ext/FLANN EXT_FLANN_SRC *.h *.cpp *.hpp *.cu)
ADD_SOURCE_DIR(ext/Graclus EXT_GRACLUS_SRC *.h *.c)
ADD_SOURCE_DIR(ext/LSD EXT_LSD_SRC *.h *.c)
ADD_SOURCE_DIR(ext/PBA EXT_PBA_SRC *.h *.cpp *.cu)
ADD_SOURCE_DIR(ext/PoissonRecon EXT_POISSON_RECON_SRC *.h *.cpp *.inl)
ADD_SOURCE_DIR(ext/SiftGPU EXT_SIFT_GPU_SRC *.h *.cpp *.cu)
ADD_SOURCE_DIR(ext/SQLite EXT_SQLITE_SRC *.h *.c)
ADD_SOURCE_DIR(ext/VLFeat EXT_VLFEAT_SRC *.h *.c *.tc)
ADD_SOURCE_DIR(feature FEATURE_SRC *.h *.cc)
ADD_SOURCE_DIR(mvs MVS_SRC *.h *.cc *.cu)
ADD_SOURCE_DIR(optim OPTIM_SRC *.h *.cc)
ADD_SOURCE_DIR(retrieval RETRIEVAL_SRC *.h *.cc)
ADD_SOURCE_DIR(sfm SFM_SRC *.h *.cc)
ADD_SOURCE_DIR(tools TOOLS_SRC *.h *.cc)
ADD_SOURCE_DIR(ui UI_SRC *.h *.cc)
ADD_SOURCE_DIR(util UTIL_SRC *.h *.cc)

# Add all of the source files to a regular library target, as using a custom
# target does not allow us to set its C++ include directories (and thus
# intellisense can't find any of the included files).
add_library(
    ${COLMAP_SRC_ROOT_FOLDER}
    ${BASE_SRC}
    ${CONTROLLERS_SRC}
    ${ESTIMATORS_SRC}
    ${EXE_SRC}
    ${EXT_FLANN_SRC}
    ${EXT_GRACLUS_SRC}
    ${EXT_LSD_SRC}
    ${EXT_PBA_SRC}
    ${EXT_POISSON_RECON_SRC}
    ${EXT_SIFT_GPU_SRC}
    ${EXT_SQLITE_SRC}
    ${EXT_VLFEAT_SRC}
    ${FEATURE_SRC}
    ${MVS_SRC}
    ${OPTIM_SRC}
    ${RETRIEVAL_SRC}
    ${SFM_SRC}
    ${TOOLS_SRC}
    ${UI_SRC}
    ${UTIL_SRC})

# Prevent the library from being compiled automatically.
set_target_properties(
    ${COLMAP_SRC_ROOT_FOLDER} PROPERTIES
    EXCLUDE_FROM_ALL 1
    EXCLUDE_FROM_DEFAULT_BUILD 1)

=== src/base/CMakeLists.txt ===
set(FOLDER_NAME "base")

COLMAP_ADD_LIBRARY(base
    camera.h camera.cc
    camera_database.h camera_database.cc
    camera_models.h camera_models.cc
    camera_rig.h camera_rig.cc
    database.h database.cc
    database_cache.h database_cache.cc
    essential_matrix.h essential_matrix.cc
    gps.h gps.cc
    graph_cut.h graph_cut.cc
    homography_matrix.h homography_matrix.cc
    image.h image.cc
    image_reader.h image_reader.cc
    line.h line.cc
    point2d.h point2d.cc
    point3d.h point3d.cc
    polynomial.h polynomial.cc
    pose.h pose.cc
    projection.h projection.cc
    reconstruction.h reconstruction.cc
    reconstruction_manager.h reconstruction_manager.cc
    scene_clustering.h scene_clustering.cc
    scene_graph.h scene_graph.cc
    similarity_transform.h similarity_transform.cc
    track.h track.cc
    triangulation.h triangulation.cc
    undistortion.h undistortion.cc
    visibility_pyramid.h visibility_pyramid.cc
    warp.h warp.cc
)

COLMAP_ADD_TEST(camera_database_test camera_database_test.cc)
COLMAP_ADD_TEST(camera_models_test camera_models_test.cc)
COLMAP_ADD_TEST(camera_rig_test camera_rig_test.cc)
COLMAP_ADD_TEST(camera_test camera_test.cc)
COLMAP_ADD_TEST(cost_functions_test cost_functions_test.cc)
COLMAP_ADD_TEST(database_cache_test database_cache_test.cc)
COLMAP_ADD_TEST(database_test database_test.cc)
COLMAP_ADD_TEST(essential_matrix_utils_test essential_matrix_test.cc)
COLMAP_ADD_TEST(gps_test gps_test.cc)
COLMAP_ADD_TEST(graph_cut_test graph_cut_test.cc)
COLMAP_ADD_TEST(homography_matrix_utils_test homography_matrix_test.cc)
COLMAP_ADD_TEST(image_test image_test.cc)
COLMAP_ADD_TEST(line_test line_test.cc)
COLMAP_ADD_TEST(point2d_test point2d_test.cc)
COLMAP_ADD_TEST(point3d_test point3d_test.cc)
COLMAP_ADD_TEST(polynomial_test polynomial_test.cc)
COLMAP_ADD_TEST(pose_test pose_test.cc)
COLMAP_ADD_TEST(projection_test projection_test.cc)
COLMAP_ADD_TEST(reconstruction_test reconstruction_test.cc)
COLMAP_ADD_TEST(reconstruction_manager_test reconstruction_manager_test.cc)
COLMAP_ADD_TEST(scene_clustering_test scene_clustering_test.cc)
COLMAP_ADD_TEST(scene_graph_test scene_graph_test.cc)
COLMAP_ADD_TEST(similarity_transform_test similarity_transform_test.cc)
COLMAP_ADD_TEST(track_test track_test.cc)
COLMAP_ADD_TEST(triangulation_test triangulation_test.cc)
COLMAP_ADD_TEST(undistortion_test undistortion_test.cc)
COLMAP_ADD_TEST(visibility_pyramid_test visibility_pyramid_test.cc)
COLMAP_ADD_TEST(warp_test warp_test.cc)

=== src/controllers/CMakeLists.txt ===
set(FOLDER_NAME "controllers")

COLMAP_ADD_LIBRARY(controllers
    automatic_reconstruction.h automatic_reconstruction.cc
    bundle_adjustment.h bundle_adjustment.cc
    hierarchical_mapper.h hierarchical_mapper.cc
    incremental_mapper.h incremental_mapper.cc
)

=== src/estimators/CMakeLists.txt ===
set(FOLDER_NAME "estimators")

COLMAP_ADD_LIBRARY(estimators
    absolute_pose.h absolute_pose.cc
    affine_transform.h affine_transform.cc
    coordinate_frame.h coordinate_frame.cc
    essential_matrix.h essential_matrix.cc
    euclidean_transform.h
    fundamental_matrix.h fundamental_matrix.cc
    generalized_absolute_pose.h generalized_absolute_pose.cc
    generalized_absolute_pose_coeffs.h generalized_absolute_pose_coeffs.cc
    generalized_relative_pose.h generalized_relative_pose.cc
    homography_matrix.h homography_matrix.cc
    pose.h pose.cc
    similarity_transform.h
    translation_transform.h
    triangulation.h triangulation.cc
    two_view_geometry.h two_view_geometry.cc
    utils.h utils.cc
)

COLMAP_ADD_TEST(absolute_pose_test absolute_pose_test.cc)
COLMAP_ADD_TEST(affine_transform_test affine_transform_test.cc)
COLMAP_ADD_TEST(coordinate_frame_test coordinate_frame_test.cc)
COLMAP_ADD_TEST(essential_matrix_test essential_matrix_test.cc)
COLMAP_ADD_TEST(estimators_utils_test utils_test.cc)
COLMAP_ADD_TEST(fundamental_matrix_test fundamental_matrix_test.cc)
COLMAP_ADD_TEST(generalized_absolute_pose_test generalized_absolute_pose_test.cc)
COLMAP_ADD_TEST(generalized_relative_pose_test generalized_relative_pose_test.cc)
COLMAP_ADD_TEST(homography_matrix_test homography_matrix_test.cc)
COLMAP_ADD_TEST(translation_transform_test translation_transform_test.cc)

=== src/exe/CMakeLists.txt ===
set(FOLDER_NAME "exe")

COLMAP_ADD_EXECUTABLE(colmap colmap.cc)

if(CUDA_ENABLED)
    target_include_directories(colmap PUBLIC ${CUDA_INCLUDE_DIRS})
endif()

=== src/ext/CMakeLists.txt ===
set(FOLDER_NAME "ext")

COLMAP_SET_THIRD_PARTY_FOLDER()

if(NOT IS_MSVC)
    string(REPLACE "-std=c++11" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
endif()

add_subdirectory(FLANN)
add_subdirectory(Graclus)
add_subdirectory(LSD)
add_subdirectory(PBA)
add_subdirectory(PoissonRecon)
add_subdirectory(SiftGPU)
add_subdirectory(SQLite)
add_subdirectory(VLFeat)

COLMAP_UNSET_THIRD_PARTY_FOLDER()

=== src/feature/CMakeLists.txt ===
set(FOLDER_NAME "feature")

COLMAP_ADD_LIBRARY(feature
    extraction.h extraction.cc
    matching.h matching.cc
    sift.h sift.cc
    types.h types.cc
    utils.h utils.cc
)

COLMAP_ADD_TEST(feature_utils_test utils_test.cc)
COLMAP_ADD_TEST(sift_test sift_test.cc)
COLMAP_ADD_TEST(types_test types_test.cc)

=== src/mvs/CMakeLists.txt ===
set(FOLDER_NAME "mvs")

COLMAP_ADD_LIBRARY(mvs
    consistency_graph.h consistency_graph.cc
    depth_map.h depth_map.cc
    fusion.h fusion.cc
    image.h image.cc
    meshing.h meshing.cc
    model.h model.cc
    normal_map.h normal_map.cc
    workspace.h workspace.cc
)

COLMAP_ADD_TEST(consistency_graph_test consistency_graph_test.cc)
COLMAP_ADD_TEST(depth_map_test depth_map_test.cc)
COLMAP_ADD_TEST(mat_test mat_test.cc)
COLMAP_ADD_TEST(normal_map_test normal_map_test.cc)

if(CUDA_ENABLED)
    set(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS} --use_fast_math")

    # Use a separate stream per thread to allow for concurrent kernel execution
    # between multiple threads on the same device.
    set(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS} --default-stream per-thread")

    if(MSVC)
        # Workaround for Visual Studio compiler error,
        # due problems with compiling too complex code.
        string(REPLACE "/Zo" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")

        # Avoid pulling in too many header files through <windows.h>
        add_definitions(-DWIN32_LEAN_AND_MEAN)
    else()
        set(CUDA_PROPAGATE_HOST_FLAGS OFF)
        set(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS} -std=c++11")

        # Fix for Ubuntu 16.04.
        add_definitions("-D_MWAITXINTRIN_H_INCLUDED")
    endif()

    COLMAP_CUDA_ADD_LIBRARY(mvs_cuda
        gpu_mat_prng.h gpu_mat_prng.cu
        gpu_mat_ref_image.h gpu_mat_ref_image.cu
        patch_match.h patch_match.cc
        patch_match_cuda.h patch_match_cuda.cu
    )

    # MSVC/NVCC cannot compile the Boost unit test suite.
    if(NOT IS_MSVC)
        COLMAP_CUDA_ADD_TEST(gpu_mat_test gpu_mat_test.cu)
    endif()
endif()

=== src/optim/CMakeLists.txt ===
set(FOLDER_NAME "optim")

COLMAP_ADD_LIBRARY(optim
    bundle_adjustment.h bundle_adjustment.cc
    combination_sampler.h combination_sampler.cc
    least_absolute_deviations.h least_absolute_deviations.cc
    progressive_sampler.h progressive_sampler.cc
    random_sampler.h random_sampler.cc
    sprt.h sprt.cc
    support_measurement.h support_measurement.cc
)

COLMAP_ADD_TEST(bundle_adjustment_test bundle_adjustment_test.cc)
COLMAP_ADD_TEST(combination_sampler_test combination_sampler_test.cc)
COLMAP_ADD_TEST(least_absolute_deviations_test
                least_absolute_deviations_test.cc)
COLMAP_ADD_TEST(loransac_test loransac_test.cc)
COLMAP_ADD_TEST(progressive_sampler_test progressive_sampler_test.cc)
COLMAP_ADD_TEST(random_sampler_test random_sampler_test.cc)
COLMAP_ADD_TEST(ransac_test ransac_test.cc)
COLMAP_ADD_TEST(support_measurement_test support_measurement_test.cc)

=== src/retrieval/CMakeLists.txt ===
set(FOLDER_NAME "retrieval")

COLMAP_ADD_LIBRARY(retrieval
    geometry.h geometry.cc
    inverted_file.h
    inverted_file_entry.h
    inverted_index.h
    utils.h
    visual_index.h
    vote_and_verify.h vote_and_verify.cc
)

COLMAP_ADD_TEST(geometry_test geometry_test.cc)
COLMAP_ADD_TEST(inverted_file_entry_test inverted_file_entry_test.cc)
COLMAP_ADD_TEST(visual_index_test visual_index_test.cc)

=== src/sfm/CMakeLists.txt ===
set(FOLDER_NAME "sfm")

COLMAP_ADD_LIBRARY(sfm
    incremental_mapper.h incremental_mapper.cc
    incremental_triangulator.h incremental_triangulator.cc
)

=== debian/changelog ===
colmap (3.4-1) unstable; urgency=medium

  * Initial release. (Closes: #882326)

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Fri, 05 Jan 2018 10:10:47 +0100

=== debian/control ===
Source: colmap
Section: science
Priority: optional
Maintainer: Gürkan Myczko <gurkan@phys.ethz.ch>
Build-Depends: debhelper (>= 11), libeigen3-dev, libgoogle-glog-dev, libceres-dev, libqt5opengl5-dev, libfreeimage-dev, libglew-dev, cmake, libboost-system-dev, libboost-program-options-dev, libboost-filesystem-dev, libboost-regex-dev, libboost-test-dev
Standards-Version: 4.1.3
Homepage: https://github.com/colmap/colmap

Package: colmap
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Structure-from-Motion and Multi-View Stereo
 This is a general-purpose Structure-from-Motion (SfM) and Multi-View
 Stereo (MVS) pipeline with a graphical and command-line interface. It
 offers a wide range of features for reconstruction of ordered and
 unordered image collections.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# skip wasting 2.3 GB for dbgsym pkg
#export DH_BUILD_MAINT_OPTIONS=noddebs
export DEB_DH_STRIP_ARGS := --no-automatic-dbgsym

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_auto_test:
	@echo skipping test
